VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2175
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   2175
   LinkTopic       =   "Form1"
   ScaleHeight     =   2175
   ScaleWidth      =   2175
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture1 
      Height          =   1935
      Left            =   120
      ScaleHeight     =   1875
      ScaleWidth      =   1875
      TabIndex        =   0
      Top             =   120
      Width           =   1935
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal Y As Long, lpPoint As Long) As Long
Private Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal Y As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Const SRCCOPY = &HCC0020
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function GetStockObject Lib "gdi32" (ByVal nIndex As Long) As Long
Private Const BLACK_PEN = 7
' **********
Private Type BITMAP '14 bytes
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type
Private Type BITMAPINFOHEADER '40 bytes
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biRUsed As Long
    biRImportant As Long
End Type
Private Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type
Private Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
    bmiColors As RGBQUAD
End Type
Private Const DIB_RGB_COLORS = 0&
Private Const BI_RGB = 0&

Private Const pixR As Integer = 3
Private Const pixG As Integer = 2
Private Const pixB As Integer = 1

Private Declare Function CreateDIBSection Lib "gdi32" (ByVal hdc As Long, pBitmapInfo As BITMAPINFO, ByVal un As Long, ByVal lplpVoid As Long, ByVal handle As Long, ByVal dw As Long) As Long
Private Declare Function GetDIBits Lib "gdi32" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long
Private Declare Function SetDIBits Lib "gdi32" (ByVal hdc As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long

Private Type BITMAPFILEHEADER
    bfType As Integer
    bfSize As Long
    bfReserved1 As Integer
    bfReserved2 As Integer
    bfOffBits As Long
End Type
' **********
Private Type MemoryBitmap
    hdc As Long
    hBM As Long
    oldhDC As Long
    wid As Long
    hgt As Long
    bitmap_info As BITMAPINFO
End Type
' Delete the bitmap and free its resources.
Private Sub DeleteMemoryBitmap(memory_bitmap As MemoryBitmap)
    SelectObject memory_bitmap.hdc, memory_bitmap.oldhDC
    DeleteObject memory_bitmap.hBM
    DeleteDC memory_bitmap.hdc
End Sub

' Draw on the memory bitmap.
Private Sub DrawOnMemoryBitmap(memory_bitmap As MemoryBitmap)
Dim pixels() As Byte
Dim x As Integer
Dim Y As Integer
Dim R As Single
Dim dR As Single
Dim G As Single
Dim dG As Single
Dim i As Integer

    ' Load the bitmap's data into an array.
    ReDim pixels(1 To 4, _
        1 To memory_bitmap.wid, _
        1 To memory_bitmap.hgt)
    GetDIBits memory_bitmap.hdc, memory_bitmap.hBM, _
        0, memory_bitmap.hgt, pixels(1, 1, 1), _
        memory_bitmap.bitmap_info, DIB_RGB_COLORS

    ' Modify the pixels.
    R = 0
    dR = 255 / memory_bitmap.hgt
    dG = 255 / memory_bitmap.wid
    For Y = 1 To memory_bitmap.hgt
        G = 0
        For x = 1 To memory_bitmap.wid
            pixels(pixB, x, Y) = 255
            pixels(pixR, x, Y) = R
            pixels(pixG, x, Y) = G
            G = G + dG
        Next x
        R = R + dR
    Next Y

    ' Set some pixels halfway down the diagonal.
    For i = 1 To memory_bitmap.hgt \ 2 Step 10
        ' Make this block of pixels green.
        For x = 0 To 10
            For Y = 0 To 10
                pixels(pixR, i + x, i + Y) = 0
                pixels(pixG, i + x, i + Y) = 255
                pixels(pixB, i + x, i + Y) = 0
            Next Y
        Next x
    Next i

    ' Copy the results back into the memory bitmap.
    SetDIBits memory_bitmap.hdc, memory_bitmap.hBM, _
        0, memory_bitmap.hgt, pixels(1, 1, 1), _
        memory_bitmap.bitmap_info, DIB_RGB_COLORS

    ' Draw the on the device context.
    SelectObject memory_bitmap.hdc, GetStockObject(BLACK_PEN)
    MoveToEx memory_bitmap.hdc, 0, 0, ByVal 0&
    LineTo memory_bitmap.hdc, memory_bitmap.wid, memory_bitmap.hgt
    MoveToEx memory_bitmap.hdc, 0, memory_bitmap.hgt, ByVal 0&
    LineTo memory_bitmap.hdc, memory_bitmap.wid, 0
End Sub
' Make a memory bitmap of the given size.
' Return the bitmap's DC.
Private Function MakeMemoryBitmap(ByVal wid As Long, ByVal hgt As Long) As MemoryBitmap
Dim result As MemoryBitmap
Dim bytes_per_scanLine As Long
Dim pad_per_scanLine As Long

    ' Create the device context.
    result.hdc = CreateCompatibleDC(0)

    ' Define the bitmap.
    With result.bitmap_info.bmiHeader
        .biBitCount = 32
        .biCompression = BI_RGB
        .biPlanes = 1
        .biSize = Len(result.bitmap_info.bmiHeader)
        .biWidth = wid
        .biHeight = hgt

        bytes_per_scanLine = ((((.biWidth * .biBitCount) + _
            31) \ 32) * 4)
        pad_per_scanLine = bytes_per_scanLine - (((.biWidth _
            * .biBitCount) + 7) \ 8)
        .biSizeImage = bytes_per_scanLine * Abs(.biHeight)
    End With

    ' Create the bitmap.
    result.hBM = CreateDIBSection( _
        result.hdc, result.bitmap_info, _
        DIB_RGB_COLORS, ByVal 0&, _
        ByVal 0&, ByVal 0&)

    ' Make the device context use the bitmap.
    result.oldhDC = SelectObject(result.hdc, result.hBM)

    ' Return the MemoryBitmap structure.
    result.wid = wid
    result.hgt = hgt
    MakeMemoryBitmap = result
End Function

Private Sub Form_Load()
Dim memory_bitmap As MemoryBitmap

    ' Create the memory bitmap.
    Picture1.ScaleMode = vbPixels
    memory_bitmap = MakeMemoryBitmap( _
        Picture1.ScaleWidth, _
        Picture1.ScaleHeight)

    ' Draw on the bitmap.
    DrawOnMemoryBitmap memory_bitmap

    ' Copy the device context into the PictureBox.
    Picture1.AutoRedraw = True
    BitBlt Picture1.hdc, 0, 0, _
        Picture1.ScaleWidth, _
        Picture1.ScaleHeight, _
        memory_bitmap.hdc, 0, 0, SRCCOPY
    Picture1.Picture = Picture1.Image

    ' Delete the memory bitmap.
    DeleteMemoryBitmap memory_bitmap
End Sub

